<?php
namespace Controller;

use Util\Utilities;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response\Message;
use Service\DeleteCascadeService;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;

class SignUp extends Crud {

	
	/** @var \Service\SignUp $signUpService */
	protected $signUpService;
	
	public function __construct(Manager $mongoManager, DeleteCascadeService $deleteCascadeService, \Service\SignUp $signUpService) {
		parent::__construct($mongoManager, $deleteCascadeService);
		$this->signUpService = $signUpService;
	}
	
	public function registerNewOrganization(DTO\Request\Row $request, DTO\Response $response){
		$row = $request->getRow();
		
		if(isset($row['ORGANIZATION_ID'])){
			$organizationId = $row['ORGANIZATION_ID'];
			$saasConnection = isset($row['SAAS_CONNECTION']) ? $row['SAAS_CONNECTION'] : null;
			
			try {
				$this->addNewOrgConnection($organizationId, $saasConnection); 
				$response->addDataSet(new DataSet('organizationId', array($organizationId)) );
	        } catch (\Exception $e) {
	            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
	        }
		} else {
			$response->setError(new DTO\Response\Error("Invalid parameters. Missing the organization id.", 500));
		}
	}

	public function addDbName($request, $response){
        header('Content-type: application/json; charset=utf-8');
        $row = $_GET;
        var_dump($_GET);
        $nrorg = $row['NRORG'];
        $isSaas = isset($row['IS_SAAS']) ? $row['IS_SAAS'] : 'N';
        $wallet = isset($row['WALLET']) ? $row['WALLET'] : null;
	    var_dump(shell_exec("php ../scripts/addDbName.php $nrorg $isSaas $wallet"));
    }
	
	public function addNewOrgConnection($organizationId, $saasConnection){
        $widgetFilterCriteria = new FilterCriteria('connection', array(
            array(
                "columnName"  => "organizationId",
                "value"       => array(strval($organizationId),intval($organizationId)),
                "operator"    => "IN")
        ));
        $connection = $this->mongoManager->findBy($widgetFilterCriteria)->getRows();
        if(empty($connection)){
            $connection = array(array());
        }
        $connection[0]['organizationId'] = $organizationId;
        $connection[0]['username'] = "zmartzeedhi";
        $connection[0]['password'] = "zmartzeedhi";
		if($saasConnection){
			$connection[0]['clientRoom'] = "5";
		}else{
            unset($connection[0]['clientRoom'] );
        }
        $this->signUpService->addNewOrgConnection($connection);

	}
}