<?php

namespace Service\ChartView;

use Zeedhi\Framework\DependencyInjection\InstanceManager;
class Grid extends ChartViewAbstract implements ChartViewInterface {

    const TYPE_ID_GRID = "56200912f038efbfa1f75105";

    public $widget;
    public $widgetData;

    function __construct($widget = null) {
        $this->widget = $widget;
        $this->widgetData = [];
    }

    public function fetchWidgetData(){
        $widget = $this->widget;
        $widgetDataService = InstanceManager::getInstance()->getService('\Service\WidgetData');
        $this->widgetData = $widgetDataService->fetchWidgetData($widget['_id'], $widget['parameters']['structureId'], null, $widget['parameters']['period'],
                $widget['parameters']['facts'], "",array(),null,null,$widget['parameters']['drillDownFilters']);
    }

    public function getColumns(){
        $columns = [];
        foreach(array_merge($this->widget["parameters"]["dimensions"], $this->widget["parameters"]["facts"]) as $zmartColumn){
            $columnParameters = $this->widget["columns"][array_search($zmartColumn, array_column($this->widget["columns"], "name"))];
            $column = [
                "name" => $zmartColumn,
                "label" => !empty($columnParameters["label"]) ? $columnParameters["label"] : $zmartColumn 
            ];
            $columns[] = $column;
        }
        return $columns;
    }

    public function getDatasource(){
        $datasource = [
            "data" => $this->widgetData,
            "limit" => 25
        ];
        return $datasource;
    }

    public function convertToNext():array {
        $this->fetchWidgetData();
        $widget = $this->widget;
        
        $indicatorNext = [
            "name" => "apexChart_" . $widget['id'],
            "id" => $widget['id'],
            "widget" => $widget,
            "viewTypeId" => self::TYPE_ID_GRID,
            "component" => "TekGrid",
            "title" => !empty($widget["label"]) ? $widget["label"] : "",
            "showExport" => true,
            "showReload" => false,
            "height" =>"100%",
            "style" =>"height: 99%;",
            "columnsButton" => true,
            "columns" => $this->getColumns(),
            "datasource" => $this->getDatasource(),
            // "events" => [
            //     "rowClick" => "{{ChartViewController.drillGrid}}",
            // ]
        ];

        $this->widget = $indicatorNext;
        return $indicatorNext;
    }
}
